declare type Props = Record<string, any>;
interface VElement {
    type: string;
    props: Props;
    children: VNode[];
}
declare type VNode = VElement | string;
declare const h: (type: string, props?: Props, ...children: VNode[]) => VElement;
interface EditAttribute {
    type: 'attribute';
    path: number[];
    propName: string;
    hole: any;
}
interface EditText {
    type: 'text';
    path: number[];
    index: number;
    hole: any;
}
declare type Edit = EditAttribute | EditText;
declare const render: (vnode: VNode, edits?: Edit[], path?: number[]) => HTMLElement | Text;
interface BlockInstance {
    props: Props;
    mount: (parent: HTMLElement) => void;
    patch: (newBlock: BlockInstance) => void;
}
declare const block: (fn: (props: Props) => VNode) => (props: Props) => BlockInstance;

export { block, h, render };
